/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
	"time"
)

// checks if the Account type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Account{}

// Account struct for Account
type Account struct {
	DisplayName           string            `json:"displayName"`
	UniqueIdentifier      string            `json:"uniqueIdentifier"`
	AccountProviderId     NullableString    `json:"accountProviderId,omitempty"`
	EmailAddress          string            `json:"emailAddress"`
	ResetPasswordRequired bool              `json:"resetPasswordRequired"`
	PersonId              NullableString    `json:"personId,omitempty"`
	AssignedScopes        []string          `json:"assignedScopes,omitempty"`
	FirstActivationDate   NullableTime      `json:"firstActivationDate,omitempty"`
	LastActivationDate    NullableTime      `json:"lastActivationDate,omitempty"`
	ResourceCategory      *ResourceCategory `json:"resourceCategory,omitempty"`
	Reassignable          *bool             `json:"reassignable,omitempty"`
	AutoReassign          *bool             `json:"autoReassign,omitempty"`
	// Deprecated
	PendingAction    *bool          `json:"pendingAction,omitempty"`
	Disabled         *bool          `json:"disabled,omitempty"`
	Blocked          *bool          `json:"blocked,omitempty"`
	SecurityIssues   *bool          `json:"securityIssues,omitempty"`
	BlockingReason   NullableString `json:"blockingReason,omitempty"`
	BlockingTime     NullableTime   `json:"blockingTime,omitempty"`
	BlockingDeadline NullableTime   `json:"blockingDeadline,omitempty"`
	ArchiveDeadline  NullableTime   `json:"archiveDeadline,omitempty"`
	DeleteDeadline   NullableTime   `json:"deleteDeadline,omitempty"`
	// Deprecated
	ExpirationDeadline  NullableTime   `json:"expirationDeadline,omitempty"`
	OwnerId             NullableString `json:"ownerId,omitempty"`
	InternalState       *ResourceState `json:"internalState,omitempty"`
	State               *ResourceState `json:"state,omitempty"`
	LastStateChangeTime NullableTime   `json:"lastStateChangeTime,omitempty"`
	ValidityLimit       NullableTime   `json:"validityLimit,omitempty"`
	Id                  NullableString `json:"id,omitempty"`
	CreationTime        *time.Time     `json:"creationTime,omitempty"`
}

type _Account Account

// NewAccount instantiates a new Account object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAccount(displayName string, uniqueIdentifier string, emailAddress string, resetPasswordRequired bool) *Account {
	this := Account{}
	this.DisplayName = displayName
	this.UniqueIdentifier = uniqueIdentifier
	this.EmailAddress = emailAddress
	this.ResetPasswordRequired = resetPasswordRequired
	return &this
}

// NewAccountWithDefaults instantiates a new Account object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAccountWithDefaults() *Account {
	this := Account{}
	return &this
}

// GetDisplayName returns the DisplayName field value
func (o *Account) GetDisplayName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DisplayName
}

// GetDisplayNameOk returns a tuple with the DisplayName field value
// and a boolean to check if the value has been set.
func (o *Account) GetDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DisplayName, true
}

// SetDisplayName sets field value
func (o *Account) SetDisplayName(v string) {
	o.DisplayName = v
}

// GetUniqueIdentifier returns the UniqueIdentifier field value
func (o *Account) GetUniqueIdentifier() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.UniqueIdentifier
}

// GetUniqueIdentifierOk returns a tuple with the UniqueIdentifier field value
// and a boolean to check if the value has been set.
func (o *Account) GetUniqueIdentifierOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UniqueIdentifier, true
}

// SetUniqueIdentifier sets field value
func (o *Account) SetUniqueIdentifier(v string) {
	o.UniqueIdentifier = v
}

// GetAccountProviderId returns the AccountProviderId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Account) GetAccountProviderId() string {
	if o == nil || IsNil(o.AccountProviderId.Get()) {
		var ret string
		return ret
	}
	return *o.AccountProviderId.Get()
}

// GetAccountProviderIdOk returns a tuple with the AccountProviderId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Account) GetAccountProviderIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.AccountProviderId.Get(), o.AccountProviderId.IsSet()
}

// HasAccountProviderId returns a boolean if a field has been set.
func (o *Account) HasAccountProviderId() bool {
	if o != nil && o.AccountProviderId.IsSet() {
		return true
	}

	return false
}

// SetAccountProviderId gets a reference to the given NullableString and assigns it to the AccountProviderId field.
func (o *Account) SetAccountProviderId(v string) {
	o.AccountProviderId.Set(&v)
}

// SetAccountProviderIdNil sets the value for AccountProviderId to be an explicit nil
func (o *Account) SetAccountProviderIdNil() {
	o.AccountProviderId.Set(nil)
}

// UnsetAccountProviderId ensures that no value is present for AccountProviderId, not even an explicit nil
func (o *Account) UnsetAccountProviderId() {
	o.AccountProviderId.Unset()
}

// GetEmailAddress returns the EmailAddress field value
func (o *Account) GetEmailAddress() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.EmailAddress
}

// GetEmailAddressOk returns a tuple with the EmailAddress field value
// and a boolean to check if the value has been set.
func (o *Account) GetEmailAddressOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.EmailAddress, true
}

// SetEmailAddress sets field value
func (o *Account) SetEmailAddress(v string) {
	o.EmailAddress = v
}

// GetResetPasswordRequired returns the ResetPasswordRequired field value
func (o *Account) GetResetPasswordRequired() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.ResetPasswordRequired
}

// GetResetPasswordRequiredOk returns a tuple with the ResetPasswordRequired field value
// and a boolean to check if the value has been set.
func (o *Account) GetResetPasswordRequiredOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ResetPasswordRequired, true
}

// SetResetPasswordRequired sets field value
func (o *Account) SetResetPasswordRequired(v bool) {
	o.ResetPasswordRequired = v
}

// GetPersonId returns the PersonId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Account) GetPersonId() string {
	if o == nil || IsNil(o.PersonId.Get()) {
		var ret string
		return ret
	}
	return *o.PersonId.Get()
}

// GetPersonIdOk returns a tuple with the PersonId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Account) GetPersonIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.PersonId.Get(), o.PersonId.IsSet()
}

// HasPersonId returns a boolean if a field has been set.
func (o *Account) HasPersonId() bool {
	if o != nil && o.PersonId.IsSet() {
		return true
	}

	return false
}

// SetPersonId gets a reference to the given NullableString and assigns it to the PersonId field.
func (o *Account) SetPersonId(v string) {
	o.PersonId.Set(&v)
}

// SetPersonIdNil sets the value for PersonId to be an explicit nil
func (o *Account) SetPersonIdNil() {
	o.PersonId.Set(nil)
}

// UnsetPersonId ensures that no value is present for PersonId, not even an explicit nil
func (o *Account) UnsetPersonId() {
	o.PersonId.Unset()
}

// GetAssignedScopes returns the AssignedScopes field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Account) GetAssignedScopes() []string {
	if o == nil {
		var ret []string
		return ret
	}
	return o.AssignedScopes
}

// GetAssignedScopesOk returns a tuple with the AssignedScopes field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Account) GetAssignedScopesOk() ([]string, bool) {
	if o == nil || IsNil(o.AssignedScopes) {
		return nil, false
	}
	return o.AssignedScopes, true
}

// HasAssignedScopes returns a boolean if a field has been set.
func (o *Account) HasAssignedScopes() bool {
	if o != nil && !IsNil(o.AssignedScopes) {
		return true
	}

	return false
}

// SetAssignedScopes gets a reference to the given []string and assigns it to the AssignedScopes field.
func (o *Account) SetAssignedScopes(v []string) {
	o.AssignedScopes = v
}

// GetFirstActivationDate returns the FirstActivationDate field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Account) GetFirstActivationDate() time.Time {
	if o == nil || IsNil(o.FirstActivationDate.Get()) {
		var ret time.Time
		return ret
	}
	return *o.FirstActivationDate.Get()
}

// GetFirstActivationDateOk returns a tuple with the FirstActivationDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Account) GetFirstActivationDateOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.FirstActivationDate.Get(), o.FirstActivationDate.IsSet()
}

// HasFirstActivationDate returns a boolean if a field has been set.
func (o *Account) HasFirstActivationDate() bool {
	if o != nil && o.FirstActivationDate.IsSet() {
		return true
	}

	return false
}

// SetFirstActivationDate gets a reference to the given NullableTime and assigns it to the FirstActivationDate field.
func (o *Account) SetFirstActivationDate(v time.Time) {
	o.FirstActivationDate.Set(&v)
}

// SetFirstActivationDateNil sets the value for FirstActivationDate to be an explicit nil
func (o *Account) SetFirstActivationDateNil() {
	o.FirstActivationDate.Set(nil)
}

// UnsetFirstActivationDate ensures that no value is present for FirstActivationDate, not even an explicit nil
func (o *Account) UnsetFirstActivationDate() {
	o.FirstActivationDate.Unset()
}

// GetLastActivationDate returns the LastActivationDate field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Account) GetLastActivationDate() time.Time {
	if o == nil || IsNil(o.LastActivationDate.Get()) {
		var ret time.Time
		return ret
	}
	return *o.LastActivationDate.Get()
}

// GetLastActivationDateOk returns a tuple with the LastActivationDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Account) GetLastActivationDateOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.LastActivationDate.Get(), o.LastActivationDate.IsSet()
}

// HasLastActivationDate returns a boolean if a field has been set.
func (o *Account) HasLastActivationDate() bool {
	if o != nil && o.LastActivationDate.IsSet() {
		return true
	}

	return false
}

// SetLastActivationDate gets a reference to the given NullableTime and assigns it to the LastActivationDate field.
func (o *Account) SetLastActivationDate(v time.Time) {
	o.LastActivationDate.Set(&v)
}

// SetLastActivationDateNil sets the value for LastActivationDate to be an explicit nil
func (o *Account) SetLastActivationDateNil() {
	o.LastActivationDate.Set(nil)
}

// UnsetLastActivationDate ensures that no value is present for LastActivationDate, not even an explicit nil
func (o *Account) UnsetLastActivationDate() {
	o.LastActivationDate.Unset()
}

// GetResourceCategory returns the ResourceCategory field value if set, zero value otherwise.
func (o *Account) GetResourceCategory() ResourceCategory {
	if o == nil || IsNil(o.ResourceCategory) {
		var ret ResourceCategory
		return ret
	}
	return *o.ResourceCategory
}

// GetResourceCategoryOk returns a tuple with the ResourceCategory field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Account) GetResourceCategoryOk() (*ResourceCategory, bool) {
	if o == nil || IsNil(o.ResourceCategory) {
		return nil, false
	}
	return o.ResourceCategory, true
}

// HasResourceCategory returns a boolean if a field has been set.
func (o *Account) HasResourceCategory() bool {
	if o != nil && !IsNil(o.ResourceCategory) {
		return true
	}

	return false
}

// SetResourceCategory gets a reference to the given ResourceCategory and assigns it to the ResourceCategory field.
func (o *Account) SetResourceCategory(v ResourceCategory) {
	o.ResourceCategory = &v
}

// GetReassignable returns the Reassignable field value if set, zero value otherwise.
func (o *Account) GetReassignable() bool {
	if o == nil || IsNil(o.Reassignable) {
		var ret bool
		return ret
	}
	return *o.Reassignable
}

// GetReassignableOk returns a tuple with the Reassignable field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Account) GetReassignableOk() (*bool, bool) {
	if o == nil || IsNil(o.Reassignable) {
		return nil, false
	}
	return o.Reassignable, true
}

// HasReassignable returns a boolean if a field has been set.
func (o *Account) HasReassignable() bool {
	if o != nil && !IsNil(o.Reassignable) {
		return true
	}

	return false
}

// SetReassignable gets a reference to the given bool and assigns it to the Reassignable field.
func (o *Account) SetReassignable(v bool) {
	o.Reassignable = &v
}

// GetAutoReassign returns the AutoReassign field value if set, zero value otherwise.
func (o *Account) GetAutoReassign() bool {
	if o == nil || IsNil(o.AutoReassign) {
		var ret bool
		return ret
	}
	return *o.AutoReassign
}

// GetAutoReassignOk returns a tuple with the AutoReassign field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Account) GetAutoReassignOk() (*bool, bool) {
	if o == nil || IsNil(o.AutoReassign) {
		return nil, false
	}
	return o.AutoReassign, true
}

// HasAutoReassign returns a boolean if a field has been set.
func (o *Account) HasAutoReassign() bool {
	if o != nil && !IsNil(o.AutoReassign) {
		return true
	}

	return false
}

// SetAutoReassign gets a reference to the given bool and assigns it to the AutoReassign field.
func (o *Account) SetAutoReassign(v bool) {
	o.AutoReassign = &v
}

// GetPendingAction returns the PendingAction field value if set, zero value otherwise.
// Deprecated
func (o *Account) GetPendingAction() bool {
	if o == nil || IsNil(o.PendingAction) {
		var ret bool
		return ret
	}
	return *o.PendingAction
}

// GetPendingActionOk returns a tuple with the PendingAction field value if set, nil otherwise
// and a boolean to check if the value has been set.
// Deprecated
func (o *Account) GetPendingActionOk() (*bool, bool) {
	if o == nil || IsNil(o.PendingAction) {
		return nil, false
	}
	return o.PendingAction, true
}

// HasPendingAction returns a boolean if a field has been set.
func (o *Account) HasPendingAction() bool {
	if o != nil && !IsNil(o.PendingAction) {
		return true
	}

	return false
}

// SetPendingAction gets a reference to the given bool and assigns it to the PendingAction field.
// Deprecated
func (o *Account) SetPendingAction(v bool) {
	o.PendingAction = &v
}

// GetDisabled returns the Disabled field value if set, zero value otherwise.
func (o *Account) GetDisabled() bool {
	if o == nil || IsNil(o.Disabled) {
		var ret bool
		return ret
	}
	return *o.Disabled
}

// GetDisabledOk returns a tuple with the Disabled field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Account) GetDisabledOk() (*bool, bool) {
	if o == nil || IsNil(o.Disabled) {
		return nil, false
	}
	return o.Disabled, true
}

// HasDisabled returns a boolean if a field has been set.
func (o *Account) HasDisabled() bool {
	if o != nil && !IsNil(o.Disabled) {
		return true
	}

	return false
}

// SetDisabled gets a reference to the given bool and assigns it to the Disabled field.
func (o *Account) SetDisabled(v bool) {
	o.Disabled = &v
}

// GetBlocked returns the Blocked field value if set, zero value otherwise.
func (o *Account) GetBlocked() bool {
	if o == nil || IsNil(o.Blocked) {
		var ret bool
		return ret
	}
	return *o.Blocked
}

// GetBlockedOk returns a tuple with the Blocked field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Account) GetBlockedOk() (*bool, bool) {
	if o == nil || IsNil(o.Blocked) {
		return nil, false
	}
	return o.Blocked, true
}

// HasBlocked returns a boolean if a field has been set.
func (o *Account) HasBlocked() bool {
	if o != nil && !IsNil(o.Blocked) {
		return true
	}

	return false
}

// SetBlocked gets a reference to the given bool and assigns it to the Blocked field.
func (o *Account) SetBlocked(v bool) {
	o.Blocked = &v
}

// GetSecurityIssues returns the SecurityIssues field value if set, zero value otherwise.
func (o *Account) GetSecurityIssues() bool {
	if o == nil || IsNil(o.SecurityIssues) {
		var ret bool
		return ret
	}
	return *o.SecurityIssues
}

// GetSecurityIssuesOk returns a tuple with the SecurityIssues field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Account) GetSecurityIssuesOk() (*bool, bool) {
	if o == nil || IsNil(o.SecurityIssues) {
		return nil, false
	}
	return o.SecurityIssues, true
}

// HasSecurityIssues returns a boolean if a field has been set.
func (o *Account) HasSecurityIssues() bool {
	if o != nil && !IsNil(o.SecurityIssues) {
		return true
	}

	return false
}

// SetSecurityIssues gets a reference to the given bool and assigns it to the SecurityIssues field.
func (o *Account) SetSecurityIssues(v bool) {
	o.SecurityIssues = &v
}

// GetBlockingReason returns the BlockingReason field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Account) GetBlockingReason() string {
	if o == nil || IsNil(o.BlockingReason.Get()) {
		var ret string
		return ret
	}
	return *o.BlockingReason.Get()
}

// GetBlockingReasonOk returns a tuple with the BlockingReason field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Account) GetBlockingReasonOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockingReason.Get(), o.BlockingReason.IsSet()
}

// HasBlockingReason returns a boolean if a field has been set.
func (o *Account) HasBlockingReason() bool {
	if o != nil && o.BlockingReason.IsSet() {
		return true
	}

	return false
}

// SetBlockingReason gets a reference to the given NullableString and assigns it to the BlockingReason field.
func (o *Account) SetBlockingReason(v string) {
	o.BlockingReason.Set(&v)
}

// SetBlockingReasonNil sets the value for BlockingReason to be an explicit nil
func (o *Account) SetBlockingReasonNil() {
	o.BlockingReason.Set(nil)
}

// UnsetBlockingReason ensures that no value is present for BlockingReason, not even an explicit nil
func (o *Account) UnsetBlockingReason() {
	o.BlockingReason.Unset()
}

// GetBlockingTime returns the BlockingTime field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Account) GetBlockingTime() time.Time {
	if o == nil || IsNil(o.BlockingTime.Get()) {
		var ret time.Time
		return ret
	}
	return *o.BlockingTime.Get()
}

// GetBlockingTimeOk returns a tuple with the BlockingTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Account) GetBlockingTimeOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockingTime.Get(), o.BlockingTime.IsSet()
}

// HasBlockingTime returns a boolean if a field has been set.
func (o *Account) HasBlockingTime() bool {
	if o != nil && o.BlockingTime.IsSet() {
		return true
	}

	return false
}

// SetBlockingTime gets a reference to the given NullableTime and assigns it to the BlockingTime field.
func (o *Account) SetBlockingTime(v time.Time) {
	o.BlockingTime.Set(&v)
}

// SetBlockingTimeNil sets the value for BlockingTime to be an explicit nil
func (o *Account) SetBlockingTimeNil() {
	o.BlockingTime.Set(nil)
}

// UnsetBlockingTime ensures that no value is present for BlockingTime, not even an explicit nil
func (o *Account) UnsetBlockingTime() {
	o.BlockingTime.Unset()
}

// GetBlockingDeadline returns the BlockingDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Account) GetBlockingDeadline() time.Time {
	if o == nil || IsNil(o.BlockingDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.BlockingDeadline.Get()
}

// GetBlockingDeadlineOk returns a tuple with the BlockingDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Account) GetBlockingDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockingDeadline.Get(), o.BlockingDeadline.IsSet()
}

// HasBlockingDeadline returns a boolean if a field has been set.
func (o *Account) HasBlockingDeadline() bool {
	if o != nil && o.BlockingDeadline.IsSet() {
		return true
	}

	return false
}

// SetBlockingDeadline gets a reference to the given NullableTime and assigns it to the BlockingDeadline field.
func (o *Account) SetBlockingDeadline(v time.Time) {
	o.BlockingDeadline.Set(&v)
}

// SetBlockingDeadlineNil sets the value for BlockingDeadline to be an explicit nil
func (o *Account) SetBlockingDeadlineNil() {
	o.BlockingDeadline.Set(nil)
}

// UnsetBlockingDeadline ensures that no value is present for BlockingDeadline, not even an explicit nil
func (o *Account) UnsetBlockingDeadline() {
	o.BlockingDeadline.Unset()
}

// GetArchiveDeadline returns the ArchiveDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Account) GetArchiveDeadline() time.Time {
	if o == nil || IsNil(o.ArchiveDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ArchiveDeadline.Get()
}

// GetArchiveDeadlineOk returns a tuple with the ArchiveDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Account) GetArchiveDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ArchiveDeadline.Get(), o.ArchiveDeadline.IsSet()
}

// HasArchiveDeadline returns a boolean if a field has been set.
func (o *Account) HasArchiveDeadline() bool {
	if o != nil && o.ArchiveDeadline.IsSet() {
		return true
	}

	return false
}

// SetArchiveDeadline gets a reference to the given NullableTime and assigns it to the ArchiveDeadline field.
func (o *Account) SetArchiveDeadline(v time.Time) {
	o.ArchiveDeadline.Set(&v)
}

// SetArchiveDeadlineNil sets the value for ArchiveDeadline to be an explicit nil
func (o *Account) SetArchiveDeadlineNil() {
	o.ArchiveDeadline.Set(nil)
}

// UnsetArchiveDeadline ensures that no value is present for ArchiveDeadline, not even an explicit nil
func (o *Account) UnsetArchiveDeadline() {
	o.ArchiveDeadline.Unset()
}

// GetDeleteDeadline returns the DeleteDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Account) GetDeleteDeadline() time.Time {
	if o == nil || IsNil(o.DeleteDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.DeleteDeadline.Get()
}

// GetDeleteDeadlineOk returns a tuple with the DeleteDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Account) GetDeleteDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.DeleteDeadline.Get(), o.DeleteDeadline.IsSet()
}

// HasDeleteDeadline returns a boolean if a field has been set.
func (o *Account) HasDeleteDeadline() bool {
	if o != nil && o.DeleteDeadline.IsSet() {
		return true
	}

	return false
}

// SetDeleteDeadline gets a reference to the given NullableTime and assigns it to the DeleteDeadline field.
func (o *Account) SetDeleteDeadline(v time.Time) {
	o.DeleteDeadline.Set(&v)
}

// SetDeleteDeadlineNil sets the value for DeleteDeadline to be an explicit nil
func (o *Account) SetDeleteDeadlineNil() {
	o.DeleteDeadline.Set(nil)
}

// UnsetDeleteDeadline ensures that no value is present for DeleteDeadline, not even an explicit nil
func (o *Account) UnsetDeleteDeadline() {
	o.DeleteDeadline.Unset()
}

// GetExpirationDeadline returns the ExpirationDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
// Deprecated
func (o *Account) GetExpirationDeadline() time.Time {
	if o == nil || IsNil(o.ExpirationDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ExpirationDeadline.Get()
}

// GetExpirationDeadlineOk returns a tuple with the ExpirationDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
// Deprecated
func (o *Account) GetExpirationDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ExpirationDeadline.Get(), o.ExpirationDeadline.IsSet()
}

// HasExpirationDeadline returns a boolean if a field has been set.
func (o *Account) HasExpirationDeadline() bool {
	if o != nil && o.ExpirationDeadline.IsSet() {
		return true
	}

	return false
}

// SetExpirationDeadline gets a reference to the given NullableTime and assigns it to the ExpirationDeadline field.
// Deprecated
func (o *Account) SetExpirationDeadline(v time.Time) {
	o.ExpirationDeadline.Set(&v)
}

// SetExpirationDeadlineNil sets the value for ExpirationDeadline to be an explicit nil
func (o *Account) SetExpirationDeadlineNil() {
	o.ExpirationDeadline.Set(nil)
}

// UnsetExpirationDeadline ensures that no value is present for ExpirationDeadline, not even an explicit nil
func (o *Account) UnsetExpirationDeadline() {
	o.ExpirationDeadline.Unset()
}

// GetOwnerId returns the OwnerId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Account) GetOwnerId() string {
	if o == nil || IsNil(o.OwnerId.Get()) {
		var ret string
		return ret
	}
	return *o.OwnerId.Get()
}

// GetOwnerIdOk returns a tuple with the OwnerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Account) GetOwnerIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.OwnerId.Get(), o.OwnerId.IsSet()
}

// HasOwnerId returns a boolean if a field has been set.
func (o *Account) HasOwnerId() bool {
	if o != nil && o.OwnerId.IsSet() {
		return true
	}

	return false
}

// SetOwnerId gets a reference to the given NullableString and assigns it to the OwnerId field.
func (o *Account) SetOwnerId(v string) {
	o.OwnerId.Set(&v)
}

// SetOwnerIdNil sets the value for OwnerId to be an explicit nil
func (o *Account) SetOwnerIdNil() {
	o.OwnerId.Set(nil)
}

// UnsetOwnerId ensures that no value is present for OwnerId, not even an explicit nil
func (o *Account) UnsetOwnerId() {
	o.OwnerId.Unset()
}

// GetInternalState returns the InternalState field value if set, zero value otherwise.
func (o *Account) GetInternalState() ResourceState {
	if o == nil || IsNil(o.InternalState) {
		var ret ResourceState
		return ret
	}
	return *o.InternalState
}

// GetInternalStateOk returns a tuple with the InternalState field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Account) GetInternalStateOk() (*ResourceState, bool) {
	if o == nil || IsNil(o.InternalState) {
		return nil, false
	}
	return o.InternalState, true
}

// HasInternalState returns a boolean if a field has been set.
func (o *Account) HasInternalState() bool {
	if o != nil && !IsNil(o.InternalState) {
		return true
	}

	return false
}

// SetInternalState gets a reference to the given ResourceState and assigns it to the InternalState field.
func (o *Account) SetInternalState(v ResourceState) {
	o.InternalState = &v
}

// GetState returns the State field value if set, zero value otherwise.
func (o *Account) GetState() ResourceState {
	if o == nil || IsNil(o.State) {
		var ret ResourceState
		return ret
	}
	return *o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Account) GetStateOk() (*ResourceState, bool) {
	if o == nil || IsNil(o.State) {
		return nil, false
	}
	return o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *Account) HasState() bool {
	if o != nil && !IsNil(o.State) {
		return true
	}

	return false
}

// SetState gets a reference to the given ResourceState and assigns it to the State field.
func (o *Account) SetState(v ResourceState) {
	o.State = &v
}

// GetLastStateChangeTime returns the LastStateChangeTime field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Account) GetLastStateChangeTime() time.Time {
	if o == nil || IsNil(o.LastStateChangeTime.Get()) {
		var ret time.Time
		return ret
	}
	return *o.LastStateChangeTime.Get()
}

// GetLastStateChangeTimeOk returns a tuple with the LastStateChangeTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Account) GetLastStateChangeTimeOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.LastStateChangeTime.Get(), o.LastStateChangeTime.IsSet()
}

// HasLastStateChangeTime returns a boolean if a field has been set.
func (o *Account) HasLastStateChangeTime() bool {
	if o != nil && o.LastStateChangeTime.IsSet() {
		return true
	}

	return false
}

// SetLastStateChangeTime gets a reference to the given NullableTime and assigns it to the LastStateChangeTime field.
func (o *Account) SetLastStateChangeTime(v time.Time) {
	o.LastStateChangeTime.Set(&v)
}

// SetLastStateChangeTimeNil sets the value for LastStateChangeTime to be an explicit nil
func (o *Account) SetLastStateChangeTimeNil() {
	o.LastStateChangeTime.Set(nil)
}

// UnsetLastStateChangeTime ensures that no value is present for LastStateChangeTime, not even an explicit nil
func (o *Account) UnsetLastStateChangeTime() {
	o.LastStateChangeTime.Unset()
}

// GetValidityLimit returns the ValidityLimit field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Account) GetValidityLimit() time.Time {
	if o == nil || IsNil(o.ValidityLimit.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ValidityLimit.Get()
}

// GetValidityLimitOk returns a tuple with the ValidityLimit field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Account) GetValidityLimitOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ValidityLimit.Get(), o.ValidityLimit.IsSet()
}

// HasValidityLimit returns a boolean if a field has been set.
func (o *Account) HasValidityLimit() bool {
	if o != nil && o.ValidityLimit.IsSet() {
		return true
	}

	return false
}

// SetValidityLimit gets a reference to the given NullableTime and assigns it to the ValidityLimit field.
func (o *Account) SetValidityLimit(v time.Time) {
	o.ValidityLimit.Set(&v)
}

// SetValidityLimitNil sets the value for ValidityLimit to be an explicit nil
func (o *Account) SetValidityLimitNil() {
	o.ValidityLimit.Set(nil)
}

// UnsetValidityLimit ensures that no value is present for ValidityLimit, not even an explicit nil
func (o *Account) UnsetValidityLimit() {
	o.ValidityLimit.Unset()
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Account) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Account) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *Account) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *Account) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *Account) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *Account) UnsetId() {
	o.Id.Unset()
}

// GetCreationTime returns the CreationTime field value if set, zero value otherwise.
func (o *Account) GetCreationTime() time.Time {
	if o == nil || IsNil(o.CreationTime) {
		var ret time.Time
		return ret
	}
	return *o.CreationTime
}

// GetCreationTimeOk returns a tuple with the CreationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Account) GetCreationTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreationTime) {
		return nil, false
	}
	return o.CreationTime, true
}

// HasCreationTime returns a boolean if a field has been set.
func (o *Account) HasCreationTime() bool {
	if o != nil && !IsNil(o.CreationTime) {
		return true
	}

	return false
}

// SetCreationTime gets a reference to the given time.Time and assigns it to the CreationTime field.
func (o *Account) SetCreationTime(v time.Time) {
	o.CreationTime = &v
}

func (o Account) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Account) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["displayName"] = o.DisplayName
	toSerialize["uniqueIdentifier"] = o.UniqueIdentifier
	if o.AccountProviderId.IsSet() {
		toSerialize["accountProviderId"] = o.AccountProviderId.Get()
	}
	toSerialize["emailAddress"] = o.EmailAddress
	toSerialize["resetPasswordRequired"] = o.ResetPasswordRequired
	if o.PersonId.IsSet() {
		toSerialize["personId"] = o.PersonId.Get()
	}
	if o.AssignedScopes != nil {
		toSerialize["assignedScopes"] = o.AssignedScopes
	}
	if o.FirstActivationDate.IsSet() {
		toSerialize["firstActivationDate"] = o.FirstActivationDate.Get()
	}
	if o.LastActivationDate.IsSet() {
		toSerialize["lastActivationDate"] = o.LastActivationDate.Get()
	}
	if !IsNil(o.ResourceCategory) {
		toSerialize["resourceCategory"] = o.ResourceCategory
	}
	if !IsNil(o.Reassignable) {
		toSerialize["reassignable"] = o.Reassignable
	}
	if !IsNil(o.AutoReassign) {
		toSerialize["autoReassign"] = o.AutoReassign
	}
	if !IsNil(o.PendingAction) {
		toSerialize["pendingAction"] = o.PendingAction
	}
	if !IsNil(o.Disabled) {
		toSerialize["disabled"] = o.Disabled
	}
	if !IsNil(o.Blocked) {
		toSerialize["blocked"] = o.Blocked
	}
	if !IsNil(o.SecurityIssues) {
		toSerialize["securityIssues"] = o.SecurityIssues
	}
	if o.BlockingReason.IsSet() {
		toSerialize["blockingReason"] = o.BlockingReason.Get()
	}
	if o.BlockingTime.IsSet() {
		toSerialize["blockingTime"] = o.BlockingTime.Get()
	}
	if o.BlockingDeadline.IsSet() {
		toSerialize["blockingDeadline"] = o.BlockingDeadline.Get()
	}
	if o.ArchiveDeadline.IsSet() {
		toSerialize["archiveDeadline"] = o.ArchiveDeadline.Get()
	}
	if o.DeleteDeadline.IsSet() {
		toSerialize["deleteDeadline"] = o.DeleteDeadline.Get()
	}
	if o.ExpirationDeadline.IsSet() {
		toSerialize["expirationDeadline"] = o.ExpirationDeadline.Get()
	}
	if o.OwnerId.IsSet() {
		toSerialize["ownerId"] = o.OwnerId.Get()
	}
	if !IsNil(o.InternalState) {
		toSerialize["internalState"] = o.InternalState
	}
	if !IsNil(o.State) {
		toSerialize["state"] = o.State
	}
	if o.LastStateChangeTime.IsSet() {
		toSerialize["lastStateChangeTime"] = o.LastStateChangeTime.Get()
	}
	if o.ValidityLimit.IsSet() {
		toSerialize["validityLimit"] = o.ValidityLimit.Get()
	}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CreationTime) {
		toSerialize["creationTime"] = o.CreationTime
	}
	return toSerialize, nil
}

func (o *Account) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"displayName",
		"uniqueIdentifier",
		"emailAddress",
		"resetPasswordRequired",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varAccount := _Account{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varAccount)

	if err != nil {
		return err
	}

	*o = Account(varAccount)

	return err
}

type NullableAccount struct {
	value *Account
	isSet bool
}

func (v NullableAccount) Get() *Account {
	return v.value
}

func (v *NullableAccount) Set(val *Account) {
	v.value = val
	v.isSet = true
}

func (v NullableAccount) IsSet() bool {
	return v.isSet
}

func (v *NullableAccount) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAccount(val *Account) *NullableAccount {
	return &NullableAccount{value: val, isSet: true}
}

func (v NullableAccount) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAccount) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
